// -------------------------------------------------------------------------------
// 
// 		cwCu		ff[^t@C
// 
// 				Ver 3.16 
// 
// -------------------------------------------------------------------------------

#ifndef __DXMODELFILE_H__
#define __DXMODELFILE_H__

// CN[h ------------------------------

#include "DxCompileConfig.h"
#include "DxLib.h"
#include "DxStatic.h"

#ifndef DX_NON_MODEL

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------

#define MV1_TRIANGLE_LIST_INDEX_TYPE_U8						(0x0000)				// CfbNXl unsigned char ^
#define MV1_TRIANGLE_LIST_INDEX_TYPE_U16					(0x0001)				// CfbNXl unsigned short ^
#define MV1_TRIANGLE_LIST_INDEX_TYPE_U32					(0x0002)				// CfbNXl unsigned dword ^

#define MV1_TRIANGLE_LIST_FLAG_MVERT_INDEX_MASK				(0x0003)				// bV_CfbNX^Cṽ}XN( MV1_TRIANGLE_LIST_INDEX_TYPE_U32  )
#define MV1_TRIANGLE_LIST_FLAG_INDEX_MASK					(0x000c)				// _CfbNX^Cṽ}XN( MV1_TRIANGLE_LIST_INDEX_TYPE_U32  )

#define MV1_FRAME_NORMAL_TYPE_NONE							(0x0000)				// @͖( vZ )
#define MV1_FRAME_NORMAL_TYPE_S8							(0x0001)				// @ signed char ^
#define MV1_FRAME_NORMAL_TYPE_S16							(0x0002)				// @ signed short ^
#define MV1_FRAME_NORMAL_TYPE_F32							(0x0003)				// @ float ^

#define MV1_FRAME_MATRIX_INDEX_TYPE_U8						(0x0000)				// sCfbNX unsigned char ^
#define MV1_FRAME_MATRIX_INDEX_TYPE_U16						(0x0001)				// sCfbNX unsigned short ^

#define MV1_FRAME_MATRIX_WEIGHT_TYPE_U8						(0x0000)				// sEGCgl unsigned char ^
#define MV1_FRAME_MATRIX_WEIGHT_TYPE_U16					(0x0001)				// sEGCgl unsigned short ^

#define MV1_FRAME_VERT_FLAG_NORMAL_TYPE_MASK				(0x0003)				// @^Cv}XN( MV1_FRAME_NORMAL_TYPE_NONE  )
#define MV1_FRAME_VERT_FLAG_POSITION_B16					(0x0004)				// ̃tOĂWl16rbg
#define MV1_FRAME_VERT_FLAG_MATRIX_WEIGHT_NONE				(0x0008)				// ̃tOĂEGCgl͖
#define MV1_FRAME_VERT_FLAG_MATRIX_INDEX_MASK				(0x0010)				// sCfbNX^Cv}XN( MV1_FRAME_MATRIX_INDEX_TYPE_U8  )
#define MV1_FRAME_VERT_FLAG_MATRIX_WEIGHT_MASK				(0x0020)				// sEGCg^Cv}XN( MV1_FRAME_MATRIX_WEIGHT_TYPE_U8  )
#define MV1_FRAME_VERT_FLAG_NOMRAL_TANGENT_BINORMAL			(0x0040)				// ̃tOĂ@́A@AڐA]@


#define MV1_MESH_VERT_INDEX_TYPE_NONE						(0x0000)				// CfbNXl͖
#define MV1_MESH_VERT_INDEX_TYPE_U8							(0x0001)				// CfbNXl unsigned char ^
#define MV1_MESH_VERT_INDEX_TYPE_U16						(0x0002)				// CfbNXl unsigned short ^
#define MV1_MESH_VERT_INDEX_TYPE_U32						(0x0003)				// CfbNXl unsigned int ^

#define MV1_MESH_VERT_FLAG_POS_IND_TYPE_MASK				(0x0003)				// WCfbNX^Cv}XN( MV1_MESH_VERT_INDEX_TYPE_U8  )
#define MV1_MESH_VERT_FLAG_NRM_IND_TYPE_MASK				(0x000c)				// @CfbNX^Cv}XN( MV1_MESH_VERT_INDEX_TYPE_U8  )
#define MV1_MESH_VERT_FLAG_UV_U16							(0x0010)				// ̃tOĂtul16rbg
#define MV1_MESH_VERT_FLAG_COMMON_COLOR						(0x0020)				// ̃tOĂ璸_J[͋ʂň
#define MV1_MESH_VERT_FLAG_NON_TOON_OUTLINE					(0x0040)				// ̃tOĂe_ɃgD[̗֊s`悷邩ǂ̏񂪊i[Ă


#define MV1_TEXTURE_FLAG_REVERSE							(0x0001)				// ̃tOĂ摜𔽓]
#define MV1_TEXTURE_FLAG_BMP32_ALL_ZERO_ALPHA_TO_XRGB8		(0x0002)				// ̃tOĂRQrbgalõAt@lׂĂÔƂ XRGB8 ƂĈ
#define MV1_TEXTURE_FLAG_VALID_SCALE_UV						(0x0004)				// ̃tOĂtuW̃XP[L


#define MV1_ANIM_KEYSET_FLAG_KEY_ONE						(0x0001)				// ̃tOĂL[͈̐
#define MV1_ANIM_KEYSET_FLAG_KEYNUM_B						(0x0002)				// ̃tOĂL[̐͂PoCg
#define MV1_ANIM_KEYSET_FLAG_KEYNUM_W						(0x0004)				// ̃tOĂL[̐͂QoCg
#define MV1_ANIM_KEYSET_FLAG_TIME_UNIT						(0x0008)				// ̃tOĂ^Cz̑ɓԊu^C񂪓Ă
#define MV1_ANIM_KEYSET_FLAG_TIME_UNIT_ST_W					(0x0010)				// ̃tOĂ^CJnlWORDl
#define MV1_ANIM_KEYSET_FLAG_TIME_UNIT_ST_Z					(0x0020)				// ̃tOĂ^CJnl͂O
#define MV1_ANIM_KEYSET_FLAG_TIME_UNIT_UN_W					(0x0040)				// ̃tOĂ^CԊulWORDl
#define MV1_ANIM_KEYSET_FLAG_TIME_BIT16						(0x0080)				// ̃tOĂ^Cz̒lPUrbgl
#define MV1_ANIM_KEYSET_FLAG_KEY_BIT16						(0x0100)				// ̃tOĂL[͂PUrbgl
#define MV1_ANIM_KEYSET_FLAG_KEY_MP_PP						(0x0200)				// ̃tOĂL[ -PI ` PI  0`65535 ŕ\
#define MV1_ANIM_KEYSET_FLAG_KEY_Z_TP						(0x0400)				// ̃tOĂL[ 0.0f ` 2 * PI  0`65535 ŕ\

// \̒` --------------------------------

// vg^Cv錾
struct MV1_MESH_SET_F1 ;
struct MV1_FRAME_F1 ;
struct MV1_MESH_F1 ;
struct MV1_ANIMSET_F1 ;

// ]\
struct MV1_ROTATE_F1
{
	int										Type ;								// ]^Cv( MV1_ROTATE_TYPE_XYZROT  )
	union
	{
		VECTOR								XYZRot ;							// XYZ]p
		FLOAT4								Qt ;								// NH[^jI]p
		MATRIX_4X4CT_F						Mat ;								// s]p
	} ;
} ;

// 16bitf[^^Cvp⏕\
struct MV1_ANIM_KEY_16BIT_F1
{
	BYTE									Min ;								// ŏl( bit7:Oǂ( 0:0ȊO 1:0 )  bit6:(0:+ 1:-)  bit5:搔(0:+ 1:-) bit4`0:搔(ő1015) ) 
	BYTE									Unit ;								// 16bitlPӂ̒l( bit7:搔(0:+ 1:-) bit6`4:搔(ő107) bit3`0:Zl( 0`15 ) )
} ;

// Aj[VL[(S~SŝSڂ(0,0,0,1)Œ̍s^Cv)f[^\
struct MV1_ANIM_KEY_MATRIX4X4C_F1
{
	float									Matrix[ 4 ][ 3 ] ;					// s
} ;

// Aj[VL[(R~Rs^Cv)f[^\
struct MV1_ANIM_KEY_MATRIX3X3_F1
{
	float									Matrix[ 3 ][ 3 ] ;					// s
} ;

// Aj[VL[(R~RsPUrbg^Cv)f[^\
struct MV1_ANIM_KEY_MATRIX3X3_B16_F1
{
	WORD									Matrix[ 3 ][ 3 ] ;					// s
} ;

// Aj[VL[Xgf[^\
/*
	KeyData ̏i[

	{

		Type  MV1_ANIMKEY_DATATYPE_SHAPE ̏ꍇ
			WORD								TargetShapeIndex ;		// Ώۂ̃VFCvCfbNX
	
		Flag  MV1_ANIM_KEYSET_FLAG_KEY_ONE tĂȂꍇ
			Flag  MV1_ANIM_KEYSET_FLAG_KEYNUM_B tĂꍇ
				BYTE							Num ;					// L[̐

			Flag  MV1_ANIM_KEYSET_FLAG_KEYNUM_W tĂꍇ
				WORD							Num ;					// L[̐

			Flag  MV1_ANIM_KEYSET_FLAG_KEYNUM_W  MV1_ANIM_KEYSET_FLAG_KEYNUM_B tĂȂꍇ
				DWORD							Num ;					// L[̐


			Flag  MV1_ANIM_KEYSET_FLAG_TIME_BIT16 tĂꍇ
				MV1_ANIM_KEY_16BIT_F1			Time16BSub ;			// 16bit^Clp⏕
				WORD ^Cl

			Flag  MV1_ANIM_KEYSET_FLAG_TIME_BIT16  MV1_ANIM_KEYSET_FLAG_TIME_UNIT ĂȂꍇ
				float ^Cl

			Flag  MV1_ANIM_KEYSET_FLAG_TIME_UNIT tĂꍇ
				Flag  MV1_ANIM_KEYSET_FLAG_TIME_UNIT_ST_W tĂꍇ
					WORD						StartTime ;				// Jn

				Flag  MV1_ANIM_KEYSET_FLAG_TIME_UNIT_ST_Z  MV1_ANIM_KEYSET_FLAG_TIME_UNIT_ST_W ĂȂꍇ
					float						StartTime ;				// Jn

				Flag  MV1_ANIM_KEYSET_FLAG_TIME_UNIT_UN_W tĂꍇ
					WORD						UnitTime ;				// Pʎ

				Flag  MV1_ANIM_KEYSET_FLAG_TIME_UNIT_UN_W tĂȂꍇ
					float						UnitTime ;				// Pʎ

		Flag  MV1_ANIM_KEYSET_FLAG_VAL_MP_PP  MV1_ANIM_KEYSET_FLAG_VAL_Z_TP tĂȂāA MV1_ANIM_KEYSET_FLAG_KEY_BIT16 tĂꍇ
			MV1_ANIM_KEY_16BIT_F1				Key16BSub ;				// 16bitL[lp⏕


	L[
		etH[}bgɉf[^

*/
struct MV1_ANIM_KEYSET_F1
{
	char									Type ;								// L[^Cv( MV1_ANIMKEY_TYPE_QUATERNION  )
	char									DataType ;							// f[^^Cv( MV1_ANIMKEY_DATATYPE_ROTATE  )
	WORD									Flag ;								// tO
	DWORD/*void* */							KeyData ;							// L[f[^

	DWORD									UserData[ 1 ] ;						// O`̏

	DWORD									Padding[ 2 ] ;
} ;

// Aj[Vf[^\
struct MV1_ANIM_F1
{
	int										Index ;								// CfbNX

	DWORD/*MV1_ANIMSET_F1* */				Container ;							// ̃Aj[VĂAj[VZbgւ̃|C^

	int										TargetFrameIndex ;					// ΏۂƂȂt[̃CfbNX
	float									MaxTime ;							// eL[Zbg̒ňԒL[Zbg̎Ԓl
	int										RotateOrder ;						// ]I[_[( MV1_ROTATE_ORDER_XYZ  )

	int										KeySetNum ;							// L[Zbg̐
	DWORD/*MV1_ANIM_KEYSET_F1* */			KeySet ;							// L[Zbgzւ̃|C^

	DWORD									UserData[ 2 ] ;						// O`̏

	DWORD									Padding[ 2 ] ;
} ;

// Aj[VZbg\
struct MV1_ANIMSET_F1
{
	DWORD/*MV1_ANIMSET_F1* */				DimPrev ;							// Õf[^ւ̃|C^
	DWORD/*MV1_ANIMSET_F1* */				DimNext ;							// ̃f[^ւ̃|C^
	DWORD/*char* */							Name ;								// Aj[VZbg

	int										Index ;								// CfbNX
	float									MaxTime ;							// eAj[V̒ňԒAj[V̎Ԓl
	int										AnimNum ;							// Aj[V̐
	DWORD/*MV1_ANIM_F1* */					Anim ;								// Aj[VXg

	DWORD									UserData[ 4 ] ;						// O`̏

	DWORD									Flag ;								// tO( 0bit:ZAj[V  1bit:L[̕Ԃ͍s`Ԃ  2bit:[vAj[V )
	DWORD									Padding[ 3 ] ;
} ;

// eNX`\
struct MV1_TEXTURE_F1
{
	DWORD/*MV1_TEXTURE_F1* */				DimPrev ;							// Õf[^ւ̃|C^
	DWORD/*MV1_TEXTURE_F1* */				DimNext ;							// ̃f[^ւ̃|C^
	DWORD/*char* */							Name ;								// eNX`IuWFNgɂꂽO
	int										Index ;								// CfbNX

	DWORD/*char* */							ColorFilePath ;						// J[`lp摜t@C̑΃pX
	DWORD/*char* */							AlphaFilePath ;						// At@`lp摜t@C̑΃pX
	int										BumpImageFlag ;						// J[`lov}bvǂ( TRUE:ov}bv  FALSE:Ⴄ )
	float									BumpImageNextPixelLength ;			// ov}bv摜̏ꍇׂ̗̃sNZƂ̋

	int										AddressModeU ;						// AhX[h( MV1_TEXTURE_ADDRESS_MODE_WRAP  )
	int										AddressModeV ;						// AhX[h( MV1_TEXTURE_ADDRESS_MODE_WRAP  )
	int										FilterMode ;						// tB^O[h( MV1_TEXTURE_FILTER_MODE_POINT  )

	DWORD									UserData[ 2 ] ;						// O`̏

	BYTE									Flag ;								// tO( MV1_TEXTURE_FLAG_REVERSE  )
	BYTE									Padding1[ 3 ] ;

	float									ScaleU ;							// tW̃XP[Ol( tO MV1_TEXTURE_FLAG_VALID_SCALE_UV Ăꍇ̂ݗL )
	float									ScaleV ;							// uW̃XP[Ol( tO MV1_TEXTURE_FLAG_VALID_SCALE_UV Ăꍇ̂ݗL )
	DWORD									Padding[ 1 ] ;
} ;

// }eAC[\
struct MV1_MATERIAL_LAYER_F1
{
	int										Texture ;							// feNX`CfbNX( MV1_MODEL_F1.Textue z̃CfbNX )
	int										BlendType ;							// uh^Cv( MV1_LAYERBLEND_TYPE_ADDITIVE  )

	DWORD									Padding[ 4 ] ;
} ;

// }eAgD[_Op\
struct MV1_MATERIAL_TOON_F1
{
	int										Type ;								// }eA^Cv( DX_MATERIAL_TYPE_NORMAL Ȃ )

	int										DiffuseGradTexture ;				// ( gD[_Oł̂ݎgp )fBt[YJ[Of[VeNX`CfbNXAĂ郉Cg̃fBt[YJ[łtl܂́Ȁꍇ́|P( MV1_MODEL_BASE.Textue z̃CfbNX )
	int										SpecularGradTexture ;				// ( gD[_Oł̂ݎgp )XyLJ[Of[VeNX`CfbNXAĂ郉Cg̃XyLJ[łtl܂́Ȁꍇ́|P( MV1_MODEL_BASE.Textue z̃CfbNX )
	int										DiffuseGradBlendType ;				// ( gD[_Oł̂ݎgp )fBt[YOf[VeNX`̃uh^Cv( DX_MATERIAL_BLENDTYPE_TRANSLUCENT Ȃ )
	int										SpecularGradBlendType ;				// ( gD[_Oł̂ݎgp )XyLOf[VeNX`̃uh^Cv( DX_MATERIAL_BLENDTYPE_ADDITIVE Ȃ )
	float									OutLineWidth ;						// ( gD[_Oł̂ݎgp )֊s̕( 0.0f ` 1.0f )
	COLOR_F									OutLineColor ;						// ( gD[_Oł̂ݎgp )֊s̐F
	float									OutLineDotWidth ;					// ( gD[_Oł̂ݎgp )֊s̃hbgPʂł̕
	BYTE									EnableSphereMap ;					// ( gD[_Oł̂ݎgp )XtBA}bv̏񂪗Lǂ( 1:L  0: )
	BYTE									SphereMapBlendType ;				// ( gD[_Oł̂ݎgp )XtBA}bveNX`̃uh^Cv( DX_MATERIAL_BLENDTYPE_ADDITIVE Ȃ )
	short									SphereMapTexture ;					// ( gD[_Oł̂ݎgp )XtBA}bveNX`CfbNX

	DWORD									Padding[ 2 ] ;
} ;

// }eA\
struct MV1_MATERIAL_F1
{
	DWORD/*MV1_MATERIAL_F1* */				DimPrev ;							// Õf[^ւ̃|C^
	DWORD/*MV1_MATERIAL_F1* */				DimNext ;							// ̃f[^ւ̃|C^
	DWORD/*char* */							Name ;								// O
	int										Index ;								// CfbNX

	COLOR_F									Diffuse ;							// fBt[YF
	COLOR_F									Ambient ;							// ArGgF
	COLOR_F									Specular ;							// XyL[F
	COLOR_F									Emissive ;							// G~bVuF
	float									Power ;								// XyLnCCg̃p[
	float									Alpha ;								// At@l

	int										DiffuseLayerNum ;					// fBt[YJ[̃C[
	MV1_MATERIAL_LAYER_F1					DiffuseLayer[ 8 ] ;					// fBt[YJ[̃C[( OC[ BlendType ͖ )
	int										SpecularLayerNum ;					// XyL}bṽC[
	MV1_MATERIAL_LAYER_F1					SpecularLayer[ 8 ] ;				// XyL}bṽC[( OC[ BlendType ͖ )
	int										NormalLayerNum ;					// @}bṽC[
	MV1_MATERIAL_LAYER_F1					NormalLayer[ 8 ] ;					// @}bṽC[( OC[ BlendType ͖ )

	int										UseAlphaTest ;						// At@eXggp邩ǂ
	int										AlphaFunc ;							// At@eXg[h( ̂Ƃ떢gp )
	int										AlphaRef ;							// At@eXg臒l

	int										DrawBlendMode ;						// õ͎uh[h( DX_BLENDMODE_NOBLEND  )
	int										DrawBlendParam ;					// õ͎uhp[^

	DWORD									UserData[ 4 ] ;						// O`̏

	DWORD/*MV1_MATERIAL_TOON_F1* */			ToonInfo ;						// gD[_Op̏Aꍇ NULL
	DWORD									Padding[ 3 ] ;
} ;

// Cg\
struct MV1_LIGHT_F1
{
	DWORD/*MV1_LIGHT_F1* */					DimPrev ;							// Õf[^ւ̃|C^
	DWORD/*MV1_LIGHT_F1* */					DimNext ;							// ̃f[^ւ̃|C^
	DWORD/*char* */							Name ;								// O
	int										Index ;								// CfbNX

	int										FrameIndex ;						// CgĂt[̃CfbNX
	int										Type ;								// Cg^Cv( MV1_LIGHT_TYPE_POINT  )
	COLOR_F									Diffuse ;							// fBt[YJ[
	COLOR_F									Specular ;							// XyLJ[
	COLOR_F									Ambient ;							// ArGgJ[
	float									Range ;								// X|bgCg̗L
	float									Falloff ;							// tH[It
	float									Attenuation0 ;						// Cgp[^O
	float									Attenuation1 ;						// Cgp[^P
	float									Attenuation2 ;						// Cgp[^Q
	float									Theta ;								// X|bgCg̓R[̊px͈
	float									Phi ;								// X|bgCg̊OR[̊px͈

	DWORD									UserData[ 2 ] ;						// O`̏
} ;

// PUrbgWlp⏕
struct MV1_POSITION_16BIT_SUBINFO_F1
{
	float									Min ;								// ŏl
	float									Width ;								// 
} ;

// gCAOXg\
/*
	MeshVertexIndexAndIndexData ̏

		gp{[
			VertexType 
				MV1_VERTEX_TYPE_NORMAL        ̏ꍇ@@Ȃ
				MV1_VERTEX_TYPE_SKIN_4BONE    ̏ꍇ@@ŏ̂QoCgɎgp{[̐ǍɂP{[ӂQoCgŎgp{[CfbNXlgp{[
				MV1_VERTEX_TYPE_SKIN_8BONE    ̏ꍇ@@ŏ̂QoCgɎgp{[̐ǍɂP{[ӂQoCgŎgp{[CfbNXlgp{[
				MV1_VERTEX_TYPE_SKIN_FREEBONE ̏ꍇ    őgp{[QoCgŊi[

		VertexNum ̐

			bV_CfbNX
				Flag  MV1_TRIANGLE_LIST_FLAG_MVERT_INDEX_MASK ɉl


		IndexNum ̐
		
			_CfbNX
				Flag  MV1_TRIANGLE_LIST_FLAG_INDEX_MASK ɉl
*/
struct MV1_TRIANGLE_LIST_F1
{
	DWORD/*MV1_TRIANGLE_LIST_F1* */			DimPrev ;						// Õf[^ւ̃|C^
	DWORD/*MV1_TRIANGLE_LIST_F1* */			DimNext ;						// ̃f[^ւ̃|C^
	int										Index ;								// CfbNX

	DWORD/*MV1_MESH_F1* */					Container ;							// ̃gCAOXgĂ郁bVւ̃|C^
	unsigned short							VertexType ;						// _^Cv( MV1_VERTEX_TYPE_NORMAL Ȃ )
	unsigned short							Flag ;								// tO( MV1_TRIANGLE_LIST_FLAG_NORMAL_S8  )
	unsigned short							VertexNum ;							// _f[^̐
	unsigned short							IndexNum ;							// _CfbNX̐
	DWORD/*void* */							MeshVertexIndexAndIndexData ;		// bV_CfbNXf[^ƒ_CfbNXf[^

	DWORD									Padding[ 2 ] ;
} ;

// XLbVp{[gpt[̏
struct MV1_SKIN_BONE_USE_FRAME_F1
{
	int										Index ;								// {[gpĂt[̃CfbNX
	int										MatrixIndex ;						// ̃{[ZbgĂt[CfbNX( MV1_FRAME_BASE.UseSkinBone ̃CfbNX )
} ;

// XLbVp{[
struct MV1_SKIN_BONE_F1
{
	DWORD/*MV1_SKIN_BONE_F1* */				DimPrev ;							// Õf[^ւ̃|C^
	DWORD/*MV1_SKIN_BONE_F1* */				DimNext ;							// ̃f[^ւ̃|C^
	int										Index ;								// CfbNX

	int										BoneFrame ;							// {[ƂĎgpt[
	MATRIX_4X4CT_F							ModelLocalMatrix ;					// fW{[̃[JWɕϊ邽߂̍s
	int										ModelLocalMatrixIsTranslateOnly ;	// fW{[̃[JWɕϊ邽߂̍s񂪕sړ݂̂ǂ( 1:sړ̂  0:]܂ )
	int										UseFrameNum ;						// ̃{[gpt[̐
	DWORD/*MV1_SKIN_BONE_USE_FRAME_F1* */	UseFrame ;							// ̃{[gpt[̏

	DWORD									Padding[ 2 ] ;
} ;

// ԕύXǗp{\
struct MV1_CHANGE_F1
{
	DWORD									Target ;							// ԕωۂɘ_aׂΏۂ̊JnAhXւ̃ItZbg( SoCgP )
	DWORD/*DWORD* */						Fill ;								// ԕωۂɘ_atOf[^
	DWORD									CheckBit ;							// ̃tOrbgrbg
	DWORD									Size ;								// ԕωۂɘ_atOf[^̃TCY( DWORD P )
} ;

// bV\
/*
	VertexData ̏i[

		ŏɈ

			VertFlag  MV1_MESH_VERT_FLAG_COMMON_COLOR tĂꍇ
				COLOR_U8			DiffuseColor ;				// ʃfBt[YF
				COLOR_U8			SpecularColor ;				// ʃXyLF

		VertexNum ̐

			WCfbNX
				VertFlag  MV1_MESH_VERT_FLAG_POS_IND_TYPE_MASK ɉl

		VertexNum ̐

			@CfbNX
				VertFlag  MV1_MESH_VERT_FLAG_NRM_IND_TYPE_MASK ɉl

		VertexNum ̐

			_J[
				VertFlag  MV1_MESH_VERT_FLAG_COMMON_COLOR tĂꍇ͖Aꍇ COLOR_U8 ^ŁAfBt[YFAXyLF̏

		VertexNum ̐

			tul
				U,V ̏ UVUnitNum * UVSetUnitNum ̐
				VertFlag  MV1_MESH_VERT_FLAG_UV_U16 tĂ WORD^( 65535  1.0 ƂŒ菬_l )AȊȌꍇ float^

		VertFlag  MV1_MESH_VERT_FLAG_NON_TOON_OUTLINE tĂꍇ VertexNum ̐

			gD[_Oɗ֊s`悵Ȃǂ̏񂪂P_PrbgŊi[A]肪Wrbg̏ꍇ͂̃oCgpfBOŎg
*/
struct MV1_MESH_F1
{
	DWORD/*MV1_MESH_F1* */					DimPrev ;							// Õf[^ւ̃|C^
	DWORD/*MV1_MESH_F1* */					DimNext ;							// ̃f[^ւ̃|C^

	int										Index ;								// CfbNX

	DWORD/*MV1_FRAME_F1* */					Container ;							// ̃bVĂt[ւ̃|C^
	DWORD/*MV1_MATERIAL_F1* */				Material ;							// gp}eAւ̃|C^

	MV1_CHANGE_F1							ChangeInfo ;						// ԕωǗp{

	int										UseVertexDiffuseColor ;				// _̃fBt[YJ[}eÃfBt[YJ[̑Ɏgp邩ǂ( TRUE:gp  FALSE:gpȂ )
	int										UseVertexSpecularColor ;			// _̃XyLJ[}eÃXyLJ[̑Ɏgp邩ǂ( TRUE:gp  FALSE:gpȂ )
	BYTE									NotOneDiffuseAlpha ;				// fBt[YJ[̃At@l 100% ȊÔ̂邩ǂ( 1:  0:Ȃ )
	BYTE									Shape ;								// VFCvbVǂ( 1:VFCvbV  0:VFCvbVł͂Ȃ )
	BYTE									Padding2[ 2 ] ;

	int										TriangleListNum ;					// gCAOXg̐
	DWORD/*MV1_TRIANGLE_LIST_F1* */			TriangleList ;						// gCAOXg̃Xgւ̃|C^

	BYTE									Visible ;							// \tO( 1:\  0:\Ȃ )
	BYTE									BackCulling ;						// obNJO邩ǂ( 2:EJO  1:JO  0:Ȃ )

	BYTE									UVSetUnitNum ;						// ̍Wf[^Ɋ܂܂eNX`WZbg̐
	BYTE									UVUnitNum ;							// ̍Wf[^Ɋ܂܂eNX`W̐

	int										VertFlag ;							// _f[^ɊւtO( MV1_MESH_VERT_FLAG_POS_IND_TYPE_MASK  )

	int										VertexNum ;							// _̐
	int										FaceNum ;							// ʂ̐
	DWORD/*void* */							VertexData ;						// _f[^

	DWORD									UserData[ 4 ] ;						// O`̏

	DWORD									Padding[ 4 ] ;
} ;

// VFCv_f[^\
struct MV1_SHAPE_VERTEX_F1
{
	int										TargetMeshVertex ;					// ΏۂƂȂ钸_ԍ( MV1_MESH_F1.Vertex ɑ΂CfbNX )
	VECTOR									Position ;							// W( ̍Wɑ΂鍷 )
	VECTOR									Normal ;							// @
} ;

// VFCvbV\
struct MV1_SHAPE_MESH_F1
{
	DWORD/*MV1_SHAPE_MESH_F1* */			DimPrev ;							// Õf[^ւ̃|C^
	DWORD/*MV1_SHAPE_MESH_F1* */			DimNext ;							// ̃f[^ւ̃|C^

	int										Index ;								// CfbNX

	DWORD/*MV1_MESH_F1* */					TargetMesh ;						// ΏۂƂȂ郁bV

	WORD									IsVertexPress ;						// _f[^kĂ邩ǂ( 1:kĂ  0:ĂȂ )
	WORD									VertexPressParam ;					// _f[^̈kp[^
	DWORD									VertexNum ;							// _f[^̐
	DWORD/*MV1_SHAPE_VERTEX_F1* */			Vertex ;							// _f[^zւ̃|C^

	DWORD									UserData[ 4 ] ;						// O`̏

	DWORD									Padding[ 4 ] ;
} ;

// VFCv\
struct MV1_SHAPE_F1
{
	DWORD/*MV1_SHAPE_F1* */					DimPrev ;							// Õf[^ւ̃|C^
	DWORD/*MV1_SHAPE_F1* */					DimNext ;							// ̃f[^ւ̃|C^

	DWORD/*char* */							Name ;								// O
	int										Index ;								// CfbNX

	DWORD/*MV1_FRAME_F1* */					Container ;							// ̃VFCvĂt[̃|C^

	int										MeshNum ;							// VFCvbV̐
	DWORD/*MV1_SHAPE_MESH_F1* */			Mesh ;								// VFCvbVzւ̃|C^

	DWORD									UserData[ 4 ] ;						// O`̏

	DWORD									Padding[ 4 ] ;
} ;

// t[ɕtVFCv
struct MV1_FRAME_SHAPE_F1
{
	int										ShapeNum ;							// t[ɕtVFCv̐
	DWORD/*MV1_SHAPE_F1* */					Shape ;								// VFCvzւ̃|C^
} ;

// Kwf[^\
/*
	PositionAndNormalData ̏i[

		ŏɈ

			VertFlag  MV1_FRAME_VERT_FLAG_POSITION_B16 tĂꍇ
				MV1_POSITION_16BIT_SUBINFO_F1	x, y, z ;				// Wl x, y, z 16rbgp⏕

		PositionNum ̐

			Wf[^
				VertFlag  MV1_FRAME_VERT_FLAG_POSITION_B16 tĂꍇ WORD^AtĂȂ float^

		PositionNum ̐

			XLjOAVertFlag  MV1_FRAME_VERT_FLAG_MATRIX_WEIGHT_NONE tĂꍇ͖
				CfbNXlAEGCgl̏ɃCfbNXl -1 ɂȂ邩AMaxBoneBlendNum ̐ɒB܂ŁACfbNXl -1 ̌ɃEGCgl͖
				CfbNXl VertFlag  MV1_FRAME_VERT_FLAG_MATRIX_INDEX_MASK  ɉl
				EGCgl     VertFlag  MV1_FRAME_VERT_FLAG_MATRIX_WEIGHT_MASK ɉl


		@AVertFlag  MV1_FRAME_VERT_FLAG_NORMAL_TYPE_MASK ̒l MV1_FRAME_NORMAL_TYPE_NONE ̏ꍇ͖
		NormalNum ̐

			@f[^
				VertFlag  MV1_FRAME_VERT_FLAG_NORMAL_TYPE_MASK ɉl

*/
struct MV1_FRAME_F1
{
	DWORD/*MV1_FRAME_F1* */					DimPrev ;							// f[^z̑O̊Kwf[^ւ̃|C^
	DWORD/*MV1_FRAME_F1* */					DimNext ;							// f[^z̎̊Kwf[^ւ̃|C^

	DWORD/*char* */							Name ;								// O
	int										Index ;								// CfbNX

	MV1_CHANGE_F1							ChangeDrawMaterialInfo ;			// `p}eAԕωǗp{
	MV1_CHANGE_F1							ChangeMatrixInfo ;					// sԕωǗp{

	int										TotalMeshNum ;						// ̉wɂ郁bV̑
	int										TotalChildNum ;						// ̉wɂt[̐
	DWORD/*MV1_FRAME_F1* */					Parent ;							// eKwւ̃|C^
	DWORD/*MV1_FRAME_F1* */					FirstChild ;						// qKwւ̃|C^([)
	DWORD/*MV1_FRAME_F1* */					LastChild ;							// qKwւ̃|C^([)
	DWORD/*MV1_FRAME_F1* */					Prev ;								// ZKwւ̃|C^
	DWORD/*MV1_FRAME_F1* */					Next ;								// Kwւ̃|C^

	VECTOR									Translate ;							// sړ
	VECTOR									Scale ;								// XP[
	VECTOR									Rotate ;							// ]
	int										RotateOrder ;						// ]I[_[
	FLOAT4									Quaternion ;						// ]( NH[^jI )

	DWORD									Flag ;								// etO( MV1_FRAMEFLAG_VISIBLE Ȃ )

	int										IsSkinMesh ;						// ̃t[Ɋ܂܂郁bV̒ɃXLbV܂܂邩ǂ( TRUE:܂܂  FALSE:܂܂Ȃ )
	int										TriangleNum ;						// ̃t[Ɋ܂܂|S̐
	int										VertexNum ;							// ̃t[Ɋ܂܂钸_f[^̐
	int										MeshNum ;							// bV̐
	DWORD/*MV1_MESH_F1* */					Mesh ;								// bVXgւ̃|C^

	int										SkinBoneNum ;						// ̃t[^[QbgƂ{[̐
	DWORD/*MV1_SKIN_BONE_F1* */				SkinBone ;							// ̃t[^[QbgƂŏ̃{[ւ̃|C^

	int										UseSkinBoneNum ;					// ̃t[gpĂ{[̐
	DWORD/*MV1_SKIN_BONE_F1** */			UseSkinBone ;						// ̃t[gpĂ{[ւ̃|C^̔z

	DWORD/*MV1_LIGHT_F1* */					Light ;								// Cgւ̃|C^

	unsigned short							VertFlag ;							// _f[^ɊւtO
	unsigned short							MaxBoneBlendNum ;					// ̍Wf[^Ŏgp{[EGCg̍ő吔

	float									SmoothingAngle ;					// @vZ̏ꍇ̃X[WOsǂ臒l( Pʂ̓WA )
	int										AutoCreateNormal ;					// @̎gp邩ǂ( TRUE:gp  FALSE:gpȂ )

	int										PositionNum ;						// W̐
	int										NormalNum ;							// @̐
	DWORD/*void* */							PositionAndNormalData ;				// WƖ@f[^

	DWORD									UserData[ 4 ] ;						// O`̏

	DWORD/*MV1_FRAME_SHAPE_F1* */			FrameShape ;						// VFCv( ꍇ NULL )

	VECTOR									PreRotate ;							// O]
	VECTOR									PostRotate ;						// ]

	DWORD									Padding[ 8 ] ;
} ;

// Zp̃f[^\
struct MV1_PHYSICS_RIGIDBODY_F1
{
	DWORD/*MV1_PHYSICS_RIGIDBODY_F1* */		DimPrev ;							// Õf[^ւ̃|C^
	DWORD/*MV1_PHYSICS_RIGIDBODY_F1* */		DimNext ;							// ̃f[^ւ̃|C^

	DWORD/*char* */							Name ;								// O
	int										Index ;								// CfbNX

	DWORD/*MV1_FRAME_F1* */					TargetFrame ;						// ΏۂƂȂt[

	int										RigidBodyGroupIndex ;				// ̃O[vԍ
	DWORD									RigidBodyGroupTarget ;				// ̃O[vΏ
	int										ShapeType ;							// `( 0:  1:  2:JvZ )
	float									ShapeW ;							// 
	float									ShapeH ;							// 
	float									ShapeD ;							// s
	VECTOR									Position ;							// ʒu
	VECTOR									Rotation ;							// ]( WA )
	float									RigidBodyWeight ;					// 
	float									RigidBodyPosDim ;					// ړ
	float									RigidBodyRotDim ;					// ]
	float									RigidBodyRecoil ;					// 
	float									RigidBodyFriction ;					// C
	int										RigidBodyType ;						// ̃^Cv( 0:BoneǏ]  1:Z  2:Z(Boneʒu킹) )
	int										NoCopyToBone ;						// {[̍s𕨗ɓKpȂǂ

	DWORD									UserData[ 4 ] ;						// O`̏

	DWORD									Padding[ 4 ] ;
} ;

// Zp̃WCgf[^\
struct MV1_PHYSICS_JOINT_F1
{
	DWORD/*MV1_PHYSICS_JOINT_F1* */			DimPrev ;							// Õf[^ւ̃|C^
	DWORD/*MV1_PHYSICS_JOINT_F1* */			DimNext ;							// ̃f[^ւ̃|C^

	DWORD/*char* */							Name ;								// O
	int										Index ;								// CfbNX

	DWORD/*MV1_PHYSICS_RIGIDBODY_F1* */		RigidBodyA ;						// ڑ捄̂`
	DWORD/*MV1_PHYSICS_RIGIDBODY_F1* */		RigidBodyB ;						// ڑ捄̂a
	VECTOR									Position ;							// ʒu
	VECTOR									Rotation ;							// ]( WA )
	VECTOR									ConstrainPosition1 ;				// ړlP
	VECTOR									ConstrainPosition2 ;				// ړlQ
	VECTOR									ConstrainRotation1 ;				// ]lP
	VECTOR									ConstrainRotation2 ;				// ]lQ
	VECTOR									SpringPosition ;					// ΂ˈړl
	VECTOR									SpringRotation ;					// ΂ˉ]l

	DWORD									UserData[ 4 ] ;						// O`̏

	DWORD									Padding[ 4 ] ;
} ;

// t@Cɕt镨Z֘Ȁ
struct MV1_FILEHEAD_PHYSICS_F1
{
	float									WorldGravity ;						// d̓p[^

	int										RigidBodyNum ;						// ̃f[^̐
	DWORD/*MV1_PHYSICS_RIGIDBODY_F1* */		RigidBody ;							// ̃f[^zւ̃|C^

	int										JointNum ;							// WCgf[^\
	DWORD/*MV1_PHYSICS_JOINT_F1* */			Joint ;								// WCgf[^zւ̃|C^

	DWORD									UserData[ 4 ] ;						// O`̏

	DWORD									Padding[ 4 ] ;
} ;

// t@CɕtVFCv֘Ȁ
struct MV1_FILEHEAD_SHAPE_F1
{
	int										FrameNum ;							// t[ɕtVFCvf[^̐
	DWORD/*MV1_FRAME_SHAPE_F1* */			Frame ;								// t[ɕtVFCvf[^zւ̃|C^

	int										DataNum ;							// VFCvf[^̐
	DWORD/*MV1_SHAPE_F1* */					Data ;								// VFCvf[^zւ̃|C^
	int										MeshNum ;							// VFCvbVf[^̐
	DWORD/*MV1_SHAPE_MESH_F1* */			Mesh ;								// VFCvbVf[^zւ̃|C^
	int										VertexNum ;							// VFCv_f[^̐
	DWORD/*MV1_SHAPE_VERTEX_F1* */			Vertex ;							// VFCv_f[^zւ̃|C^
	int										PressVertexDataSize ;				// kꂽVFCv_f[^̃TCY
	DWORD/*void* */							PressVertexData ;					// kꂽVFCv_f[^ւ̃|C^
	int										TargetMeshVertexNum ;				// VFCvΏۂ̃bV̒_̑
	int										ShapeVertexUnitSize ;				// VFCvp_ӂ̃oCg

	int										NormalPositionNum ;					// VFCvpgCAOXg̃{[񖳂Wf[^̐
	int										SkinPosition4BNum ;					// VFCvpgCAOXĝS{[XLjObVWf[^̐
	int										SkinPosition8BNum ;					// VFCvpgCAOXĝW{[XLjObVWf[^̐
	int										SkinPositionFREEBSize ;				// VFCvpgCAOXĝX{[ȏXLjObVWf[^̃TCY

	DWORD									UserData[ 4 ] ;						// O`̏

	DWORD									Padding[ 4 ] ;
} ;

// t@Cwb_
struct MV1MODEL_FILEHEADER_F1
{
	BYTE									CheckID[ 4 ] ;						// t@C``FbNphc( "MV11" )
	DWORD									Version ;							// o[W

	int										RightHandType ;						// EWnǂ( TRUE:EWn  FALSE:Wn )
	int										AutoCreateNormal ;					// @̎gp邩ǂ( TRUE:gp  FALSE:gpȂ )

	int										ChangeDrawMaterialTableSize ;		// `}eA̕ύXǗpɕKvȃf[^̑e
	int										ChangeMatrixTableSize ;				// s̕ύXǗpɕKvȃf[^̑e
	DWORD/*DWORD* */						ChangeDrawMaterialTable ;			// `p}eAύXmFprbgf[^
	DWORD/*DWORD* */						ChangeMatrixTable ;					// sύXmFprbgf[^

	int										FrameNum ;							// Kwf[^̐
	DWORD/*MV1_FRAME_F1* */					Frame ;								// Kwf[^Xgւ̃|C^
	int										TopFrameNum ;						// ŏʊKw̃t[̐
	DWORD/*MV1_FRAME_F1* */					FirstTopFrame ;						// ŏʊKw̍ŏ̃t[ւ̃|C^
	DWORD/*MV1_FRAME_F1* */					LastTopFrame ;						// ŏʊKw̍Ō̃t[ւ̃|C^
	int										FrameUseSkinBoneNum ;				// t[gpĂ{[̑
	DWORD/*MV1_SKIN_BONE_F1** */			FrameUseSkinBone ;					// t[gpĂ{[ւ̃|C^

	int										MaterialNum ;						// }eA̐
	DWORD/*MV1_MATERIAL_F1* */				Material ;							// }eAf[^Xgւ̃|C^

	int										TextureNum ;						// eNX`̐
	DWORD/*MV1_TEXTURE_F1* */				Texture ;							// eNX`f[^Xgւ̃|C^

	int										MeshNum ;							// bV̐
	DWORD/*MV1_MESH_F1* */					Mesh ;								// bVf[^Xgւ̃|C^

	int										LightNum ;							// Cg̐
	DWORD/*MV1_LIGHT_F1* */					Light ;								// Cgf[^zւ̃|C^

	int										SkinBoneNum ;						// XLjObṼ{[ƂĎgpt[̏̐
	DWORD/*MV1_SKIN_BONE_F1* */				SkinBone ;							// XLjObṼ{[ƂĎgpt[̏
	int										SkinBoneUseFrameNum ;				// XLjObṼ{[gpt[̐
	DWORD/*MV1_SKIN_BONE_USE_FRAME_F1** */	SkinBoneUseFrame ;					// XLjObṼ{[gpt[

	int										TriangleListNum ;					// gCAOXg̐
	DWORD/*MV1_TRIANGLE_LIST_F1* */			TriangleList ;						// gCAOXg̃Xgւ̃|C^

	DWORD/*void* */							VertexData ;						// _f[^
	DWORD									VertexDataSize ;					// _f[^̃TCY

	int										TriangleListNormalPositionNum ;		// Z[uÕ{[񖳂Wf[^̐
	int										TriangleListSkinPosition4BNum ;		// Z[uÔS{[XLjObVWf[^̐
	int										TriangleListSkinPosition8BNum ;		// Z[uÔW{[XLjObVWf[^̐
	int										TriangleListSkinPositionFREEBSize ;	// Z[uÔX{[ȏXLjObVWf[^̃TCY
	int										MeshPositionSize ;					// bVW̃f[^TCY
	int										MeshNormalNum ;						// bV@̐
	int										MeshVertexSize ;					// bV_̃f[^TCY
	int										MeshFaceNum ;						// bVʏ̐
	int										MeshVertexIndexNum ;				// _CfbNXf[^̑
	int										TriangleListIndexNum ;				// gCAOXg̃CfbNXf[^̑

	int										TriangleNum ;						// Op`̐
	int										TriangleListVertexNum ;				// gCAOXg̒_f[^̐

	int										StringSize ;						// f[^̃TCY
	DWORD/*char* */							StringBuffer ;						// f[^ւ̃|C^

	int										OriginalAnimKeyDataSize ;			// ۑÕAj[VL[f[^̃TCY
	int										AnimKeyDataSize ;					// Aj[VL[f[^TCY
	DWORD/*void* */							AnimKeyData ;						// Aj[VL[f[^ւ̃|C^

	int										AnimKeySetNum ;						// Aj[VL[Zbg̐
	int										AnimKeySetUnitSize ;				// Aj[VL[Zbg\̈ӂ̃TCY
	DWORD/*MV1_ANIM_KEYSET_F1* */			AnimKeySet ;						// Aj[VL[ZbgXgւ̃|C^

	int										AnimNum ;							// Aj[V̐
	int										AnimUnitSize ;						// Aj[V\̈ӂ̃TCY
	DWORD/*MV1_ANIM_F1* */					Anim ;								// Aj[Vf[^Xgւ̃|C^

	int										AnimSetNum ;						// Aj[VZbg̐
	DWORD/*MV1_ANIMSET_F1* */				AnimSet ;							// Aj[VZbgXgւ̃|C^

	DWORD									UserData[ 4 ] ;						// O`̏

	DWORD/*MV1_FILEHEAD_SHAPE_F1* */		Shape ;								// VFCvɊւA݂Ȃꍇ NULL
	DWORD/*MV1_FILEHEAD_PHYSICS_F1* */		Physics ;							// Zp̏A݂Ȃꍇ NULL

	BYTE									MaterialNumberOrderDraw ;			// 蓖ĂĂ}eA̔ԍႢbV`悷邩ǂ( 1:  0:Ȃ )
	BYTE									IsStringUTF8 ;						// StringBuffer Ɋi[Ă镶 UTF-8 ǂ( 1:UTF-8  0:Shift-JIS )

	BYTE									Padding1[ 2 ] ;
	DWORD									Padding2[ 13 ] ;
} ;


// f[^錾 --------------------------------

// ֐vg^Cv錾 ----------------------

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif	// DX_NON_MODEL

#endif

