// -------------------------------------------------------------------------------
// 
// 		cwCu		_VF[_[`R[h
// 
// 				Ver 3.16 
// 
// -------------------------------------------------------------------------------

// ʕ

#include "../../../Main/Windows/DxShader_VS_D3D9.h"

// _VF[_[̓
struct VS_INPUT
{
	float4 Position        : POSITION ;			// W( [J )
	float3 Normal          : NORMAL0 ;			// @( [J )
	float4 Diffuse         : COLOR0 ;			// fBt[YJ[
	float4 Specular        : COLOR1 ;			// XyLJ[
	float4 TexCoords0      : TEXCOORD0 ;		// eNX`W
	float4 TexCoords1      : TEXCOORD1 ;		// TueNX`W

#ifdef BUMPMAP
	// ov}bv
	float3 Tan             : TANGENT0 ;			// ڐ( [J )
	float3 Bin             : BINORMAL0 ;		// ]@( [J )
#endif // BUMPMAP

#ifdef SKINMESH
	// XLjObV
	int4   BlendIndices0   : BLENDINDICES0 ;	// {[p Float^萔zCfbNXO
	float4 BlendWeight0    : BLENDWEIGHT0 ;		// {[pEGCglO

	#ifdef BONE8

		int4   BlendIndices1   : BLENDINDICES1 ;	// {[p Float^萔zCfbNXP
		float4 BlendWeight1    : BLENDWEIGHT1 ;		// {[pEGCglP

	#endif // BONE8

#endif // SKINMESH
} ;

// _VF[_[̏o
struct VS_OUTPUT
{
	float4 Position        : POSITION ;		// W( vWFNV )
	float4 Diffuse         : COLOR0 ;		// fBt[YJ[
	float4 Specular        : COLOR1 ;		// XyLJ[
	float4 TexCoords0_1    : TEXCOORD0 ;	// xy:eNX`W zw:TueNX`W
	float3 VPosition       : TEXCOORD1 ;	// W( r[ )
	float3 VNormal         : TEXCOORD2 ;	// @( r[ )
#ifdef BUMPMAP
	float3 VTan            : TEXCOORD3 ;    // ڐ( r[ )
	float3 VBin            : TEXCOORD4 ;    // ]@( r[ )
#endif // BUMPMAP
	float2 Fog_ShadowMap3PosZ             : TEXCOORD5 ;	// tHOp[^( x )ƃVhE}bvR̃CgW( y )

#if SHADOWMAP
	float4 ShadowMap1Pos_ShadowMap3PosX   : TEXCOORD6 ;	// VhE}bvP̃CgW( x, y, z )ƃVhE}bvR̃CgXW( w )
	float4 ShadowMap2Pos_ShadowMap3PosY   : TEXCOORD7 ;	// VhE}bvQ̃CgW( x, y, z )ƃVhE}bvR̃CgYW( w )
#endif // SHADOWMAP
} ;

// _VF[_[̃}eAp[^
struct VS_CONST_MATERIAL
{
	float4 Diffuse ;				// fBt[YJ[
	float4 Specular ;				// XyLJ[
	float4 Power ;					// XyL̋
} ;




// C++ Őݒ肷萔̒`
float4              cfZeroOne                                                  : register( c0  /* DX_VS_CONSTF_ZERO_ONE              */ ) ;	// OƂP̒萔( x:0.0f  y:1.0f )
float4              cfProjectionMatrix[ 4 ]                                    : register( c2  /* DX_VS_CONSTF_PROJECTION_MAT        */ ) ;	// r[@@vWFNVs
float4              cfViewMatrix[ 3 ]                                          : register( c6  /* DX_VS_CONSTF_VIEW_MAT              */ ) ;	// [h@@r[s
float4              cfFog                                                      : register( c10 /* DX_VS_CONSTF_FOG                   */ ) ;	// tHOpp[^( x:end/(end - start)  y:-1/(end - start)  z:density  w:Rΐ̒ )

VS_CONST_MATERIAL   cfMaterial                                                 : register( c11 /* DX_VS_CONSTF_MATERIAL_START        */ ) ;	// }eAp[^
float4              cfToonOutLineSize                                          : register( c42 /* DX_VS_CONSTF_TOON_OUTLINE_SIZE     */ ) ;	// gD[̗֊s̑傫
float4              cfDifSpeSource                                             : register( c43 /* DX_VS_CONSTF_DIF_SPE_SOURCE        */ ) ;	// x:fBt[YJ[( 0.0f:}eA  1.0f:_ )  y:XyLJ[( 0.0f:}eA  1.0f:_ )

float4              cfShadowMap1LightViewProjectionMatrix[ 4 ]                 : register( c44 /* DX_VS_CONSTF_SHADOWMAP1_LIGHT_VIEW_PROJECTION_MAT */ ) ;	// VhE}bvPp̃Cgr[sƃCgˉesZ
float4              cfShadowMap2LightViewProjectionMatrix[ 4 ]                 : register( c48 /* DX_VS_CONSTF_SHADOWMAP2_LIGHT_VIEW_PROJECTION_MAT */ ) ;	// VhE}bvQp̃Cgr[sƃCgˉesZ
float4              cfShadowMap3LightViewProjectionMatrix[ 4 ]                 : register( c52 /* DX_VS_CONSTF_SHADOWMAP3_LIGHT_VIEW_PROJECTION_MAT */ ) ;	// VhE}bvRp̃Cgr[sƃCgˉesZ

float4              cfTextureMatrix[ DX_VS_CONSTF_TEXTURE_MATRIX_NUM ][ 2 ]    : register( c88 /* DX_VS_CONSTF_TEXTURE_MATRIX_START  */ ) ;	// eNX`Wps
float4              cfLocalWorldMatrix[ DX_VS_CONSTF_WORLD_MAT_NUM * 3 ]       : register( c94 /* DX_VS_CONSTF_WORLD_MAT_START       */ ) ;	// [J@@[hs




#define FOG_LINEAR_ADD          cfFog.x
#define FOG_LINEAR_DIV          cfFog.y
#define FOG_EXP_DENSITY         cfFog.z
#define FOG_EXP_E               cfFog.w

#ifdef SKINMESH
#define LOCAL_WORLD_MAT         lLocalWorldMatrix
#else
#define LOCAL_WORLD_MAT         cfLocalWorldMatrix
#endif
/*
#ifdef DIF_MAT
#define DIF                     cfMaterial.Diffuse
#endif

#ifdef DIF_VTX
#define DIF                     VSInput.Diffuse
#endif

#ifdef SPE_MAT
#define SPE                     cfMaterial.Specular
#endif

#ifdef SPE_VTX
#define SPE                     VSInput.Specular
#endif
*/
#define TEXMTX0_U               cfTextureMatrix[ 0 ][ 0 ]
#define TEXMTX0_V               cfTextureMatrix[ 0 ][ 1 ]


